package xtc.samples.dom;

import xtc.driver.*;
import xtc.driver.XTCdom.*;
import xtc.server.XTCexception;

class AddAuthor
{
    static XTCconnection connection = null;
    
    static final int numberOfAuthorsToAdd = 1;

    public static void main (String[] args)
    {
        if (args.length != 4)
        {
            System.out.println ("\n\nWrong parameters: <host> <port> <username> <password> required.");
            System.exit (0);
        }

        String host           = args[0];
        int    port           = new Integer(args[1]).intValue();
        String username       = args[2];
        String password       = args[3];

        try
        {
            connection = XTCdriver.getConnection (host, port, username, password);
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
            connection.beginWork ("Add author");

            org.w3c.dom.Document document = connection.getDocument ("sample.xml");

            org.w3c.dom.Node contextNode = document.getDocumentElement ();

            // navigate to first book element
            contextNode = contextNode.getFirstChild ();

            // navigate to next sibling book element
            contextNode = contextNode.getNextSibling ();

            for (int i=0; i < numberOfAuthorsToAdd; i++)
            {
                // append new author with element and contained text to this book element
				org.w3c.dom.Element authorNode = document.createElement("author");
                authorNode = (Element)contextNode.appendChild(authorNode);
                
				org.w3c.dom.Element lastNameNode = document.createElement("last");
                lastNameNode  = (Element)authorNode.appendChild(lastNameNode);
				org.w3c.dom.Element firstNameNode = document.createElement("first");
                firstNameNode = (Element)authorNode.insertBefore(firstNameNode, lastNameNode);
                
				org.w3c.dom.Text firstName = document.createTextNode("firstName");
                firstNameNode.appendChild(firstName);
				org.w3c.dom.Text lastName = document.createTextNode("lastName");
                lastNameNode.appendChild (lastName);
            }
            System.out.println ("Authors added.");
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
            connection.commitWork ();
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        connection.close ();
        
        System.out.println ("Exit.");
    } // main

} // class AddAuthor