package xtc.samples.dom;

import xtc.driver.*;
import xtc.server.XTCexception;

class GetElementById
{
    static XTCconnection connection = null;

    public static void main (String[] args)
    {
        if (args.length != 4)
        {
            System.out.println ("\n\nWrong parameters: <host> <port> <username> <password> required.");
            System.exit (0);
        }

        String host           = args[0];
        int    port           = new Integer(args[1]).intValue();
        String username       = args[2];
        String password       = args[3];

        try
        {
            connection = XTCdriver.getConnection (host, port, username, password);
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
			System.out.println ("Get <book> element by ID 'book2':");
		
            connection.beginWork ("Get element by ID");

            org.w3c.dom.Document document = connection.getDocument ("sample.xml");

            org.w3c.dom.Node contextNode = document.getElementById ("book2");

            if (contextNode != null)
            {
                org.w3c.dom.Node title       = contextNode.getFirstChild ();
                org.w3c.dom.Node titleText   = title.getFirstChild ();

                System.out.println ("Located tag name = <" + contextNode.getNodeName() + ">");
                System.out.println ("Located title: " + titleText.getNodeValue());
				
				System.out.println ("Accessing DOM nodes via deweyID:");
				String bookNameDeweyID   = ((xtc.driver.XTCdom.Node)contextNode).getXTCnameID();
				String bookValueDeweyID  = ((xtc.driver.XTCdom.Node)contextNode).getXTCvalueID();
				String titleNameDeweyID  = ((xtc.driver.XTCdom.Node)titleText).getXTCnameID();
				String titleValueDeweyID = ((xtc.driver.XTCdom.Node)titleText).getXTCvalueID();
				System.out.println ("Book element nameDeweyID=" + bookNameDeweyID + " valueDeweyID=" + bookValueDeweyID);
				System.out.println ("Title node nameDeweyID=" + titleNameDeweyID + " valueDeweyID=" + titleValueDeweyID);
				
				System.out.println ("Reloading nodes directly via deweyID:");
				org.w3c.dom.Node book2 = ((xtc.driver.XTCdom.Document)document).getNode(bookNameDeweyID);
				System.out.println ("Reloaded book element: <" + book2.getNodeName() + ">");
				
				org.w3c.dom.Node title2 = ((xtc.driver.XTCdom.Document)document).getNode(titleNameDeweyID);
				System.out.println ("Reloaded title node: " + title2.getNodeValue());
            }
            else System.out.println ("Element with ID attribute value 'book2' not found.");
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
            connection.commitWork ();
            connection.close ();
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }
    } // main

} // class GetElementById