package xtc.samples.dom;

import xtc.driver.*;
import xtc.driver.XTCdom.*;
import xtc.server.XTCexception;

class SetAttribute
{
    static XTCconnection connection = null;

    public static void main (String[] args)
    {
        if (args.length != 4)
        {
            System.out.println ("\n\nWrong parameters: <host> <port> <username> <password> required.");
            System.exit (0);
        }

        String host           = args[0];
        int    port           = new Integer(args[1]).intValue();
        String username       = args[2];
        String password       = args[3];

        try
        {
            connection = XTCdriver.getConnection (host, port, username, password);
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
            connection.beginWork ("Set attribute");

            org.w3c.dom.Document document = connection.getDocument ("sample.xml");

            org.w3c.dom.Node contextNode = document.getDocumentElement ();

            // navigate to first book element
            contextNode = contextNode.getFirstChild ();
            
            // navigate to first child of book element
            contextNode = contextNode.getFirstChild ();
            
            // search first author element
            while (contextNode != null)
            {
                if ((contextNode.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE) && (contextNode.getNodeName().equals("author")))
                {
                    ((Element)contextNode).setAttribute ("authorID", "author1");
                    System.out.println ("Attribute set.");
                    break;
                }
                
                contextNode = contextNode.getNextSibling ();
            }
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }

        try
        {
            connection.commitWork ();
            connection.close ();
        }
        catch (XTCexception e)
        {
            System.out.println (e.getMessage());
            System.exit (0);
        }
    } // main

} // class SetAttribute